#include "munga.h"
#pragma hdrstop

#include "audtools.h"

#include <fstream>
#include <io.h>
#include <sys\stat.h>

#include "audio.h"
#include "boxsolid.h"

AudioCreateSymbols::AudioCreateSymbols()
{
}

AudioCreateSymbols::~AudioCreateSymbols()
{
}

void AudioCreateSymbols::MakeFileReadWrite(const CString &file_name)
{
	if (access(file_name, 0) == 0)
	{
		int amode = S_IREAD|S_IWRITE;
		#if DEBUG_LEVEL>0
			int ret =
		#endif
		chmod(file_name, amode);
		Verify(ret == 0);
	}
}

void AudioCreateSymbols::Execute()
{
	CString file_name("audio\\symbols.scp");

	MakeFileReadWrite(file_name);

	std::ofstream symbol_file(file_name, std::ios::out);

	Verify(symbol_file);
	symbol_file << "[macro]\n";

	WriteEntryStream(symbol_file);
}

void AudioCreateSymbols::WriteEntryStream(std::ofstream &symbol_file)
{
	#define WRITE_ENTRY(name)\
		{\
			Verify(symbol_file);\
			symbol_file << #name;\
			symbol_file << "=";\
			symbol_file << name;\
			symbol_file << "\n";\
		}

	//
	// Solids
	//
	WRITE_ENTRY(BoxedSolid::StoneMaterial);
	WRITE_ENTRY(BoxedSolid::GravelMaterial);
	WRITE_ENTRY(BoxedSolid::ConcreteMaterial);
	WRITE_ENTRY(BoxedSolid::WoodMaterial);
	WRITE_ENTRY(BoxedSolid::RockMaterial);
	WRITE_ENTRY(BoxedSolid::OurCraftMaterial);
	WRITE_ENTRY(BoxedSolid::OtherCraftMaterial);

	//
	// Audio
	//
	WRITE_ENTRY(TransientAudioRenderType);
	WRITE_ENTRY(SustainedAudioRenderType);

	WRITE_ENTRY(MinAudioSourcePriority);
	WRITE_ENTRY(LowAudioSourcePriority);
	WRITE_ENTRY(MedAudioSourcePriority);
	WRITE_ENTRY(HighAudioSourcePriority);
	WRITE_ENTRY(MaxAudioSourcePriority);

	WRITE_ENTRY(MinAudioSourceMixPresence);
	WRITE_ENTRY(LowAudioSourceMixPresence);
	WRITE_ENTRY(MedAudioSourceMixPresence);
	WRITE_ENTRY(HighAudioSourceMixPresence);
	WRITE_ENTRY(MaxAudioSourceMixPresence);
	WRITE_ENTRY(ManualAudioSourceMixPresence);

	WRITE_ENTRY(NullAudioControlID);
	WRITE_ENTRY(NoteAudioControlID);
	WRITE_ENTRY(AttackVolumeAudioControlID);
	WRITE_ENTRY(AttackTimeAudioControlID);
	WRITE_ENTRY(DurationAudioControlID);
	WRITE_ENTRY(VolumeAudioControlID);
	WRITE_ENTRY(PitchAudioControlID);
	WRITE_ENTRY(BrightnessAudioControlID);
	WRITE_ENTRY(StartAudioControlID);
	WRITE_ENTRY(StopAudioControlID);
	WRITE_ENTRY(IdleAudioControlID);
	WRITE_ENTRY(FlushMessagesAudioControlID);
	WRITE_ENTRY(TempoAudioControlID);
}
